<template>
  <main class="main-container">
    <h3>The fellowship of the tretton37</h3>
    <div class="col-span-3 filters flex justify-content-center">
      <div class="filter-container w-1/2">
        <label class="w-1/4 text-gray-600" for="filter">Filter: </label>
        <input v-model="filterBy" id="filter" type="text" class="w-3/4 border border-gray-300"/>
      </div>
      <div class="sort-container w-1/2">
        <label class="w-1/4 text-gray-600" for="sort">Sort: </label>
        <select v-model="sortBy" class="border border-gray-300 w-3/4" id=sort>
          <option val="Name">Name</option>
          <option val="Office">Office</option>
        </select>
      </div>
    </div>

    <div class="grid grid-cols-2 md:grid-cols-4 gap-2 md:gap-8">
      <Colleague
        v-for="colleague in sortedAndFilteredColleagues"
        :key="colleague.name"
        :colleague="colleague"
      />
    </div>
  </main>
</template>

<script>
import Colleague from './Colleague'
export default {
  name: 'Colleagues',
  data () {
    return {
      sortBy: 'Name',
      filterBy: ''
    }
  },
  components: {
    Colleague
  },
  computed: {
    colleagues () {
      return this.$store.state.colleagues
    },
    sortedAndFilteredColleagues () {
      let colleagues = [...this.colleagues].sort((a, b) => {
        if (this.sortBy === 'Name') {
          return a.name.localeCompare(b.name)
        } else {
          return a.city.localeCompare(b.city)
        }
      })
      colleagues = colleagues.filter(colleague => {
        const filterBy = this.filterBy.toLowerCase()
        const name = colleague.name.toLowerCase()
        const city = colleague.city.toLowerCase()
        return name.includes(filterBy) || city.includes(filterBy)
      })
      return colleagues
    }
  },
  mounted () {
    this.$store.dispatch('fetchColleagues')
  }
}
</script>

<style scoped lang="scss">
.main-container {
  background: #f8f8f8;
  padding: 20px;
  min-width: 45%;
}
@media only screen and (max-width: 768px) {
  .main-container {
    padding: 8px;
  }
}

@media only screen and (max-width: 768px) {
  .main-container {
    padding: 8px;
  }
}

h3 {
  font-weight: bold;
  margin-bottom: 20px;
}
.filters {
  box-shadow: 2px 4px 5px rgba(0,0,0,0.2);
  padding: 10px;
  margin-bottom: 20px;
  background: #fff;
  text-align: center;
}

@media only screen and (max-width: 640px) {
  .filters > * {
    display: flex;
    flex-direction: column;
    align-items: center;
  }
}

ul {
  list-style-type: none;
  padding: 0;
}

li {
  display: inline-block;
  margin: 0 10px;
}

a {
  color: #42b983;
}

select {
  background: #fff;
  option {
    background: #fff;
  }
}

</style>
